de.caff.generics.function

## Interface BooleanOperator2

- Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface BooleanOperator2

  Binary operator with two boolean arguments and a boolean result.
  Since:
    October 31, 2019
  Author:
    Rammi

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static BooleanOperator2` | `AND` Standard short-cut boolean AND (`&&`) operator.
    `static BooleanOperator2` | `BIN_AND` Default no-short boolean AND (`&`) operator.
    `static BooleanOperator2` | `BIN_OR` Default no-short boolean OR (`|`) operator.
    `static BooleanOperator2` | `OR` Standard short-cut boolean OR (`||`) operator.
    `static BooleanOperator2` | `XOR` Default boolean XOR (`^`) XOR operator.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default BooleanOperator2` | `andThen(BooleanOperator1 after)` Create a function which applies this function and feeds the result into the next function.
    `boolean` | `applyAsBoolean(boolean arg1, boolean arg2)` Apply the function.
    `default BooleanOperator1` | `partialLeft(boolean argument)` Get a partially applied function.
    `default BooleanOperator1` | `partialRight(boolean argument)` Get a partially applied function.

- - ### Field Detail

    - #### AND

          static final BooleanOperator2 AND

      Standard short-cut boolean AND (`&&`) operator.

    - #### BIN_AND

          static final BooleanOperator2 BIN_AND

      Default no-short boolean AND (`&`) operator.

    - #### OR

          static final BooleanOperator2 OR

      Standard short-cut boolean OR (`||`) operator.

    - #### BIN_OR

          static final BooleanOperator2 BIN_OR

      Default no-short boolean OR (`|`) operator.

    - #### XOR

          static final BooleanOperator2 XOR

      Default boolean XOR (`^`) XOR operator.

  - ### Method Detail

    - #### applyAsBoolean

          boolean applyAsBoolean(boolean arg1,
                                 boolean arg2)

      Apply the function.
      Parameters:
        `arg1` - first argument
        `arg2` - second argument
      Returns:
        result of the function

    - #### partialLeft

          @NotNull
          default BooleanOperator1 partialLeft(boolean argument)

      Get a partially applied function.
      Parameters:
        `argument` - value applied for first argument
      Returns:
        partially evaluated function

    - #### partialRight

          @NotNull
          default BooleanOperator1 partialRight(boolean argument)

      Get a partially applied function.
      Parameters:
        `argument` - value applied for second argument
      Returns:
        partially evaluated function

    - #### andThen

          @NotNull
          default BooleanOperator2 andThen(@NotNull
                                                    BooleanOperator1 after)

      Create a function which applies this function and feeds the result into the next function.
      Parameters:
        `after` - function called with the result of this function
      Returns:
        chained function